'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
'@ Filename    : SNOWFLAKE                       *   *              *          @
'@ Revision    : 1.0           *                  * *            *  *  *       @
'@ Controller  : ATMEGA16                      * * * * *          * * *        @
'@ Compiler    : BASCOM-AVR 1.11.9.0   *          * *          *** * * ***     @
'@ Author      : Rubashka Vasiliy, Ukraine, 2008 *   *            * * *        @
'@ WWW      *  : http://lightportal.at.ua                        *  *  *       @
'@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
'
'                             !!!!! F U S E   B I T !!!!!
'
'LOCKBITS [FF]        --------------------------------------------------------------------------------
'Lockbit 65           11:No restrictions for SPM or LPM accessing the boot loader section
'Lockbit 43           11:No restrictions for SPM or LPM accessing the application section
'Lockbit 21           11:No memory lock features enabled for parallel and serial programming
'FUSEBITS [E4]        --------------------------------------------------------------------------------
'Fusebit C            1:BODLEVEL 2.7V
'Fusebit B            1:BODEN disabled
'Fusebit KLA987       100100:Int. RC Osc. 8 MHz; Start-up time: 6 CK + 64 ms; [CKSEL=0100 SUT=10]
'FUSEBITS HIGH [DF]   --------------------------------------------------------------------------------
'Fusebit High M       1:Disable OCD
'Fusebit High J       1:Disable JTAG
'Fusebit High l       0:SPI enabled
'Fusebit High H       1:CKOPT 1
'Fusebit High G       1:Erase EEPROM when chip erase
'Fusebit High FE      11:128 Words boot size , F80
'Fusebit High D       1:Reset vector is $0000
'#####################################################################################################

$crystal = 8000000                                          '  8 MHz
$regfile = "m16def.dat"                                     ' 
'  -  
Config Porta = Output
Config Portb = Output
Config Portc = Output
Config Portd = Output

Enable Interrupts                                           ' 
Config Timer0 = Timer , Prescale = 1                        ' 
Enable Timer0                                               '   0
On Timer0 Pwms                                              '  0
Stop Timer0                                                 '  0

Dim Led(32) As Byte                                         '  
Dim X(32) As Byte                                           '    
Dim Channel As Byte                                         ' 
Dim Lamda As Byte                                           ' 
Dim Tetta As Byte                                           ' 
Dim Tik As Byte                                             '  

'#####################################################################################################
'   ,     
' ,        
For Channel = 1 To 32
Readeeprom Led(channel) , Channel
Next
Start Timer0                                                '  0
'#####################################################################################################

Do                                                          ' 
'   32      
'        ,
'    .
' : 1  - 32 , 2  - 31 ,    32*31=992 
'   32     192  160: 192*191*190* ... *162*161*160 = 1,2 e+74. !!!!!!!!!!

For Tetta = 1 To 32
   For Channel = 1 To 32
    Incr Led(channel)
    Lamda = 192 - Channel
    If Led(channel) = Lamda Then Led(channel) = 0
    X(channel) = Lookup(led(channel) , Pwm_led)
   Next
 Writeeeprom Led(tetta) , Tetta                             '   ,    
Next
Loop                                                        '  
'#####################################################################################################

Pwms:                                                       '   0 -  
Incr Tik

If Tik = 255 Then
 Tik = 0
 Porta = 0
 Portb = 0
 Portc = 0
 Portd = 0
End If

If Tik > X(1) Then Portb.0 = 1
If Tik > X(2) Then Portb.1 = 1
If Tik > X(3) Then Portb.2 = 1
If Tik > X(4) Then Portb.3 = 1
If Tik > X(5) Then Portb.4 = 1
If Tik > X(6) Then Porta.5 = 1
If Tik > X(7) Then Porta.4 = 1
If Tik > X(8) Then Porta.3 = 1

If Tik > X(9) Then Porta.2 = 1
If Tik > X(10) Then Porta.0 = 1
If Tik > X(11) Then Porta.1 = 1
If Tik > X(12) Then Porta.6 = 1
If Tik > X(13) Then Porta.7 = 1
If Tik > X(14) Then Portc.7 = 1
If Tik > X(15) Then Portb.7 = 1
If Tik > X(16) Then Portd.0 = 1

If Tik > X(17) Then Portb.6 = 1
If Tik > X(18) Then Portb.5 = 1
If Tik > X(19) Then Portc.6 = 1
If Tik > X(20) Then Portc.5 = 1
If Tik > X(21) Then Portd.1 = 1
If Tik > X(22) Then Portd.2 = 1
If Tik > X(23) Then Portd.3 = 1
If Tik > X(24) Then Portc.3 = 1

If Tik > X(25) Then Portc.4 = 1
If Tik > X(26) Then Portd.4 = 1
If Tik > X(27) Then Portd.5 = 1
If Tik > X(28) Then Portd.6 = 1
If Tik > X(29) Then Portc.2 = 1
If Tik > X(30) Then Portc.1 = 1
If Tik > X(31) Then Portc.0 = 1
If Tik > X(32) Then Portd.7 = 1

Return

'#####################################################################################################

Pwm_led:                                                    '  
'            -  ,
'            ,    
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 254 , 253 , 252 , 250 , 249 , 247 , 244 , 241 , 237 , 231 , 224 , 204 , 202 , 186 , 166 , 139 , 105 , 59
Data 0 , 59 , 105 , 139 , 166 , 186 , 202 , 204 , 224 , 231 , 237 , 241 , 244 , 247 , 249 , 250 , 252 , 253
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 254 , 253 , 252 , 250 , 249 , 247 , 244 , 241 , 237 , 231 , 224 , 204 , 202 , 186 , 166 , 139 , 105 , 59
Data 0 , 59 , 105 , 139 , 166 , 186 , 202 , 204 , 224 , 231 , 237 , 241 , 244 , 247 , 249 , 250 , 252 , 253
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255
Data 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255

'#####################################################################################################